python-rulec
===

[![Copr build status](https://copr.fedorainfracloud.org/coprs/jwass3/example-rust-python/package/python-rulec/status_image/last_build.png)](https://copr.fedorainfracloud.org/coprs/jwass3/example-rust-python/package/python-rulec/)

[File Access Policy](https://github.com/linux-application-whitelisting/fapolicyd) rule compiler.

Like fagenrules, but with validation provided by the [`fapolicy-rules`](https://crates.io/crates/fapolicy-rules) crate from [fapolicy-analyzer](https://github.com/ctc-oss/fapolicy-analyzer)

This is mostly a toy project for experimenting with RPM builds using Python+Rust+Copr.

```text
#! python -m rulec sample.invalid.rules 
Error: 
   ╭─[sample.rules:1:1]
   │
 1 │ allow perm=any uid=0 trust=x : all
   ·                            ┬  
   ·                            ╰── Expected boolean (0, 1) value
───╯
Error: 
   ╭─[sample.rules:2:1]
   │
 2 │ allow perm=xany uid=1000 trust=1 : all
   ·            ──┬─  
   ·              ╰─── Expected one of 'any', 'open', 'execute'
───╯
Error: 
   ╭─[sample.rules:4:1]
   │
 4 │ xdeny_syslog perm=execute all : all
   · ──────┬─────  
   ·       ╰─────── Unknown Decision
───╯
```

## With Copr

```shell
dnf copr enable jwass3/example-rust-python
dnf install python-rulec
```

## With Podman

1. `vendor.sh`
2. `podman build --security-opt seccomp=unconfined -t rpm-test:rawhide .`
3. `podman run --rm -it rpm-test:rawhide`

## License

GPL v3
